<template>
  <div class="calendar mt-4">
    <div
      class="
        calendar__switcher
        d-flex
        justify-content-start
        align-items-center
        position-relative
        mb-3
      "
    >
      <button
        class="
          calendar__switcher__button calendar__switcher__button--prev
          btn btn-transparent
        "
        v-if="days.length > 7"
        @click="sliderPrev()"
      >
        <i class="fas fa-angle-left"></i>
      </button>
      <button
        class="
          calendar__switcher__button calendar__switcher__button--next
          btn btn-transparent
        "
        v-if="days.length > 7"
        @click="sliderNext()"
      >
        <i class="fas fa-angle-right"></i>
      </button>
      <div ref="slider" class="w-100">
        <div
          class="
            calendar__day
            d-flex
            justify-content-center
            align-items-center
            flex-column
            text-center
            w-100
            cursor-pointer
          "
          :class="{ 'calendar__day--active': currentDate == day }"
          v-for="day in days"
          :key="day"
          @click="setDate(day)"
        >
          <span class="text-excelsior-caps fs-14 d-block w-100">{{
            getGroupTitle(day)
          }}</span>
          <span class="text-excelsior-caps fs-11 opacity-50"
            >{{ getDay(day) }} {{ getMonth(day) }}</span
          >
        </div>
      </div>
    </div>
    <div class="calendar__list">
      <h3 class="text-dark-blue text-excelsior-caps mb-3">
        {{ getDay(currentDate) }} {{ getMonth(currentDate) }}
      </h3>
      <div class="calendar__table">
        <div
          class="
            calendar__match
            col-12
            d-flex
            justify-content-between
            align-items-center
            py-3
            position-relative
          "
          v-for="match in matches"
          :key="match.id"
        >
          <a :href="`/match/${match.id}`" class="overlay-link"></a>
          <div
            class="h-100 text-excelsior-caps"
            v-show="!match.match_type.disable_group"
          >
            <span class="bg-transparent color-gray mr-2 border border-gray p-2"
              >{{ match.home_id.group.title }} {{
            }}</span>
            {{ trans("website.group") }}
          </div>
          <div
            class="
              calendar__match__section
              d-flex
              justify-content-center
              align-items-center
              h-100
            "
          >
            <div
              class="
                calendar__match__block
                d-flex
                justify-content-end
                align-items-center
                mx-2
              "
            >
              <span class="text-excelsior-caps mr-2">{{
                match.home_id.name
              }}</span>
              <img
                class="calendar__match__img"
                :src="'/storage/' + match.home_id.logo"
              />
            </div>
            <div
              class="
                calendar__match__result
                justify-content-center
                d-flex
                align-items-center
                mx-2
              "
            >
              <span
                class="py-2 px-3"
                v-if="match.home_score !== null || match.away_score !== null"
                >{{ match.home_score }} - {{ match.away_score }}</span
              >
              <span class="py-2 px-3 bg-light-gray text-black" v-else>{{
                match.play_date | matchHours
              }}</span>
            </div>
            <div class="calendar__match__block d-flex align-items-center mx-2">
              <img
                class="calendar__match__img"
                :src="'/storage/' + match.away_id.logo"
              />
              <span class="text-excelsior-caps ml-2">{{
                match.away_id.name
              }}</span>
            </div>
            <!-- <div class="d-flex align-items-center mx-2">
              <p>{{ match.stadium }} </p>
            </div>-->
          </div>
          <div class="h-100">
            <i class="fas fa-play-circle fa-2x text-red"></i>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import axios from "axios";
import moment from "moment";
import Siema from "siema";

export default {
  name: "Calendar",
  data() {
    return {
      today: "",
      schedule: {},
      translations: {},
      currentDate: "",
      slider: null,
      isMobileAct: this.isMobile()
    };
  },
  mounted() {
    axios.get("/api/calendar").then(({ data }) => {
      this.today = data.today;
      this.schedule = data.schedule;
      this.translations = data.translations;
      this.currentDate =
        data.schedule[data.today] !== undefined
          ? data.today
          : Object.keys(data.schedule)[0];
      this.$nextTick(this.initSlider.bind(this));
      this.setCurrentDayClose();
    });
  },
  methods: {
    isMobile() {
      if (screen.width <= 760) {
        return true;
      } else {
        return false;
      }
    },
    setCurrentDayClose() {
      const closest = this.days.reduce(
        function(a, b) {
          //   return a - b;
          return a.Date - this.today < b.Date - this.today ? a : b;
        }.bind(this)
      );
      console.log(this.isMobile);
      this.setDate(closest);
    },
    trans(key) {
      if (Object.keys(this.translations).length > 0) {
        return this.get(key, this.translations);
      }
      return key;
    },
    get(key, obj) {
      return key.split(".").reduce((prev, curr) => {
        return prev[curr];
      }, obj);
    },
    getGroupTitle(day) {
      return this.schedule[day][0] !== undefined &&
        this.schedule[day][0].match_type !== undefined
        ? this.schedule[day][0].match_type.title
        : "";
    },
    getMonth(date) {
      if (date) {
        return this.trans(
          "calendar." +
            moment(date)
              .format("MMMM")
              .toLowerCase()
        );
      }
      return "";
    },
    getDay(date) {
      if (date) {
        return moment(date).format("D");
      }
      return "";
    },
    setDate(key) {
      this.currentDate = key;
    },
    initSlider() {
      if (this.isMobile()) {
        this.slider = new Siema({
          selector: this.$refs.slider,
          perPage: 3
        });
      } else {
        this.slider = new Siema({
          selector: this.$refs.slider,
          perPage: 7
        });
      }
    },
    sliderPrev() {
      if (this.slider === null) {
        return;
      }
      this.slider.prev();
    },
    sliderNext() {
      if (this.slider === null) {
        return;
      }
      this.slider.next();
    }
  },
  computed: {
    days() {
      return Object.keys(this.schedule);
    },
    matches() {
      const matches = this.schedule[this.currentDate];
      return matches !== undefined ? matches : [];
    }
  },
  filters: {
    matchHours(val) {
      return moment(val).format("HH:mm");
    }
  }
};
</script>

<style lang="scss">
</style>
